/* Subgame C: Squares */

unsigned char *n_side,*n_rotate,*n_land,*n_match;

void infoscreenC()
{
	if (seeninfo['C']) return;
	seeninfo['C']=1;
	titlepal(gamma);
	memset(shad,0,40*xres);
	memset(shad+40*xres,160,400*xres);
	memset(shad+440*xres,0,40*xres);
	bwrite(60,60,xres,"Subgame C:",15);
	bwrite(60,80,xres,"Squares",200);
	write(60,100,xres/2-60,"Objective",0,1);
	write(60,110,xres/2-60,"Something to do with destroying squares.",15,200);
	write(60,120,xres/2-60,"Risks",0,1);
	write(60,130,xres/2-60,"Something to do with piling up squares.",15,200);
	write(60,170,xres/2-60,"Rewards",0,1);
	write(60,180,xres/2-60,"You score points for doing things to do with squares.",15,200);
	write(60,220,xres/2-60,"I haven't made this subgame yet.",15,200);
	ccl(0); Sleep(500);
	while (!kbhit && !dealwithmessages());
	writepal(gamma);
}

void calclevelC(int *q,int *r)
{
	int n,i,j,*a=(int *)malloc((clevel+1)*sizeof(int)),p[26];
	for (n=1;n<=clevel;n++) a[n]=0;
	for (n=1;n<=25;n++) p[n]=625/(26-n)-24;
	for (n=25;n>=1;n--)
	{
		j=0;
		for (i=1;i<=clevel;i++)
		{
			if (!a[i]) j++;
			if (j==p[n]) {a[i]=n; j=0;}
		}
	}
	i=a[clevel]; j=0;
	for (n=1;n<clevel;n++) j+=(a[n]==i);
	*q=i; *r=j;
}

void bluebox(const int x,const int y,const int xs,const int ys)
{
	if (xs<12 || ys<0) return;
	circlefill(x,y+ys/2,ys/2,250); circlefill(x+xs,y+ys/2,ys/2,250);
	circlefill(x,y+ys/2,ys/2-3,238); circlefill(x+xs,y+ys/2,ys/2-3,238);
	circlefill(x,y+ys/2,ys/2-6,1); circlefill(x+xs,y+ys/2,ys/2-6,1);
	rect(x,y,xs,ys,250);
	rect(x,y+3,xs,ys-6,238);
	rect(x,y+6,xs,ys-12,1);
}

unsigned char player_colours[MAXP][13]=
	{{252,227,202,177,152,147,142,137,132,131,130,129,128},
	{252,247,242,237,232,231,230,229,228,203,178,153,128},
	{252,251,250,249,248,248,218,218,188,188,158,158,128},
	{252,227,202,177,152,152,146,146,140,140,134,134,128}};

unsigned char *squ[100];

void make_squares()
{
	int n,i,j,x,y;
	for (n=0;n<=29;n++) // Making square bitmaps
	{
		squ[n]=(unsigned char *)malloc(258);
		squ[n][0]=squ[n][1]=16;
		for (x=0;x<16;x++)
			for (y=0;y<16;y++)
			{
				i=2+x+y*16;
				if (n==0) squ[n][i]=0; // Black/grey background
				else if (n>=1 && n<=16) // Bevelled grey blocks
				{
					squ[n][i]=22+rnd(4);
					if ((n-1)&8 && x==0) squ[n][i]+=4;
					if ((n-1)&2 && x==15) squ[n][i]-=4;
					if ((n-1)&1 && y==0) squ[n][i]+=4;
					if ((n-1)&4 && y==15) squ[n][i]-=4;
					if (squ[n][i]<16) squ[n][i]=16;
					if (squ[n][i]>31) squ[n][i]=31;
				}
				else if (n>=17 && n<=20) // Green arrow blocks
				{
					int rx=x,ry=y;
					squ[n][i]=22+rnd(4);
					if (x==0) squ[n][i]+=4;
					if (x==15) squ[n][i]-=4;
					if (y==0) squ[n][i]+=4;
					if (y==15) squ[n][i]-=4;
					if (squ[n][i]<16) squ[n][i]=16;
					if (squ[n][i]>31) squ[n][i]=31;
					for (j=0;j<n-17;j++) {int orx=rx; rx=ry; ry=15-orx;}
					if (rx>=3 && rx<13 && fabs(ry-7.5)<7-(rx+1)/2) squ[n][i]=253;
				}
				else if (n==21) // Dark grey blocks
				{
					squ[n][i]=18+rnd(4);
					if (x==0) squ[n][i]+=4;
					if (x==15) squ[n][i]-=4;
					if (y==0) squ[n][i]+=4;
					if (y==15) squ[n][i]-=4;
					if (squ[n][i]<16) squ[n][i]=16;
					if (squ[n][i]>31) squ[n][i]=31;
				}
				else if (n>=22 && n<=29) // Coloured Colunms blocks
				{
					unsigned char a,b,c;
					if (n==22) {a=132; b=131; c=130;}
					else if (n==23) {a=152; b=146; c=140;}
					else if (n==24) {a=148; b=143; c=138;}
					else if (n==25) {a=248; b=218; c=188;}
					else if (n==26) {a=228; b=203; c=178;}
					else if (n==27) {a=230; b=204; c=178;}
					else if (n==28) {a=232; b=206; c=180;}
					else if (n==29) {a=252; b=221; c=190;}
					squ[n][i]=a;
					if (x==1 || x==14 || y==1 || y==14) squ[n][i]=b;
					if (x==0 || x==15 || y==0 || y==15) squ[n][i]=c;
				}
			}
	}
}

void plot_all_squares(const int grid[40][40])
{
	int x,y;
	for (x=0;x<40;x++)
		for (y=10;y<40;y++)
			wrapbitb(x*16,(y-10)*16,squ[grid[x][y]]);
}

int findroom(const int grid[40][40],int ret)
{
	int x,y;
	char noroom=1;
	if (ret<0) ret=0;
	if (ret>31) ret=31;
	while (noroom)
	{
		noroom=0;
		for (x=0;x<9;x++)
			for (y=0;y<9;y++)
				if (grid[ret+x][y]) noroom=1;
		if (noroom)
		{
			if (ret<16) ret++;
			if (ret>16) ret--;
			if (ret==16) noroom=0;
		}
	}
	return ret;
}

void wrapbitboth(const int x,const int y,const unsigned char *bit)
{
	wrapbitb(x,y,bit);
	wrapbit(x,y,bit);
}

void plotsquare(int x,int y,const int t,const int cx)
{
	if (y<10) return;
	x*=16; y=(y-10)*16;
	wrapbitb(x,y,squ[t]);
	wrapbit(x,y,squ[t]);
}

void clearbgsquare(const int x,const int y)
{
	if (y>=10) wrapbitb(x*16,(y-10)*16,squ[0]);
}
/*cj*/
void makesoundsC()
{
	int n,i;
	float *n_temp=(float *)malloc(3100*sizeof(float));
	n_side=(unsigned char *)malloc(250);
	for (n=0;n<250;n++)
		n_side[n]=n/6%2*180+68+n%12*(n/6%2*-2+1)*3;
	n_rotate=(unsigned char *)malloc(3000);
	for (n=0;n<3100;n++) n_temp[n]=128;
	for (n=0;n<3000;n++)
	{
		i=7+(n/300%2==0);
		n_temp[n]=(n/i%2*180-90+n%(i*2)*(n/i%2*-2+1)*3)*(3000-n)/3000+128;
		n_rotate[n]=n_temp[n];
	}
	n_land=(unsigned char *)malloc(2000);
	for (n=0;n<3100;n++) n_temp[n]=128;
	n_temp[0]=150;		// Quieter land sound
	for (n=0;n<2000;n++)
	{
		n_temp[n]=n_temp[n-1];
		if (!rnd(10)) n_temp[n]=(256.0-n_temp[n])*0.985;
		n_land[n]=n_temp[n];
	}
	n_match=(unsigned char *)malloc(3000);
	for (n=0;n<3100;n++) n_temp[n]=128;
	for (n=0;n<3000;n++)
	{
		n_temp[n]=sin(n)*(3000-n)/80+sin(n/3)*(3000-n)/80+sin(n/4)*(3000-n)/80+128;
		n_match[n]=n_temp[n];
	}
	free(n_temp);
}
/*/cj*/
void freesoundsC()
{
	free(n_side); free(n_rotate); free(n_land); free(n_match);
}

enum sg_retcode subgameC(const int them) /* Subgame C: Squares */
{
	int p,n,i,j,k,x,y;
	char str[100];
	char *subtitle[25]={"First level","Second level","Third level","Fourth level","Fifth level",
		"Sixth level","Seventh level","Eighth level","Ninth level","Tenth level",
		"Eleventh level","Twelfth level","Thirteenth level","Fourteenth level","Fifteenth level",
		"Sixteenth level","Seventeenth level","Eighteenth level","Nineteenth level","Twentieth level",
		"Twenty-first level","Twenty-second level","Twenty-third level","Twenty-fourth level","Twenty-fifth level"};
	int grid[40][40]; unsigned char **conx; // Grid: (40*30)*(16*16)
	int fmax=1000,fm; // Falling blocks
	int *fx=(int *)malloc(fmax*sizeof(int)),*fy=(int *)malloc(fmax*sizeof(int)),
		*ft=(int *)malloc(fmax*sizeof(int)),**fc=(int **)malloc(fmax*sizeof(int *));
	float *ff=(float *)malloc(fmax*sizeof(float)),*ffs=(float *)malloc(fmax*sizeof(float));
	int emax=10000,em; // Explosion dust particles
	float *ex=(float *)malloc(emax*sizeof(float)),*ey=(float *)malloc(emax*sizeof(float)),
		*exs=(float *)malloc(emax*sizeof(float)),*eys=(float *)malloc(emax*sizeof(float));
	unsigned char *ec=(unsigned char *)malloc(emax);
	int vmax=100,vm; // Visual effects
	int *vt=(int *)malloc(vmax*sizeof(int)),*vs=(int *)malloc(vmax*sizeof(int));
	float *vx=(float *)malloc(vmax*sizeof(float)),*vy=(float *)malloc(vmax*sizeof(float)),
		*vxs=(float *)malloc(vmax*sizeof(float)),*vys=(float *)malloc(vmax*sizeof(float));
	int block[MAXP][9][9],px[MAXP],py[MAXP],redbonus[MAXP],cp=0;
	float fall[MAXP],grav;
	int got,levq,levrep,level_readout;
	int pass,complete,minsize,maxsize;
	int ldelay[MAXP],rdelay[MAXP],rotdelay[MAXP];
	float dt=1;
	enum sg_retcode ret=TBA;
	infoscreenC();
	calclevelC(&levq,&levrep);
	if (sound_working) makesoundsC();
	make_squares();
	for (n=0;n<fmax;n++) fc[n]=(int *)malloc(4*sizeof(int));
	conx=(unsigned char **)malloc(40*sizeof(unsigned char *));
	for (x=0;x<40;x++) conx[x]=(unsigned char *)malloc(40);
begin_C_level:
	for (x=0;x<40;x++) for (y=0;y<40;y++) // Initial level setup
	{
		grid[x][y]=0;
		if (x<13 || x>24) grid[x][y]=21;
		if (y<39)
		{
			if (x==13) grid[x][y]=17;
			if (x==24) grid[x][y]=19;
		}
		else grid[x][y]=21;
	}
	plot_all_squares(grid);
	got=0;
	if (levq==1) {pass=250; complete=750; minsize=maxsize=4; grav=0.5;}
	else {pass=250; complete=600; minsize=3; maxsize=6; grav=0.2;}
	grav*=levrep+1;
	for participants(p) // Players initialisation
	{
		px[p]=findroom(grid,p*9); py[p]=0;
		for (x=0;x<9;x++) for (y=0;y<9;y++) block[p][x][y]=0;
		fall[p]=16;
		ldelay[p]=rdelay[p]=rotdelay[p]=0;
		redbonus[p]=1;
	}
	em=vm=fm=0; level_readout=300;
	while (ret==TBA) // <C> Main Loop
	{
		double framestart=GetTickCount();
		if (KEY(VK_P)) if (pause()) return Error;
		if (KEY(VK_ESCAPE) || KEY(VK_F12)) {mouseoff(); ret=Quit;}
		pal(253,0,192.0+63.0*sin(0.01*framestart),0);
		for (n=0;n<fm;n++) // Falling squares loop (1 of 4)
		{
			ff[n]-=ffs[n]*dt;
			ffs[n]+=0.1*(1.0-ffs[n]/16)*dt;
		}
		for (x=0;x<40;x++) // (2 of 4)
		{
			char going=1;
			while (going)
			{
				going=0;
				for (n=0;n<fm;n++) if (fx[n]==x)
					for (i=0;i<fm;i++) if (fx[i]==x)
					{
						float yn=(fy[n]-10)*16-ff[n],yi=(fy[i]-10)*16-ff[i];
						if (yn<yi && yn>yi-16)
						{
							ff[n]++;
							if (ff[n]>=16) {ff[n]=0; fy[n]--;}
							going=1;
						}
					}
			}
		}
		for (n=0;n<fm;n++) if (ff[n]<0) // (3 of 4)
		{
			if (grid[fx[n]][fy[n]+1]) // Hits the ground
			{
				char going=1,*joined=(char *)malloc(fm);
				int *rcx=(int *)malloc(fm*sizeof(int)),*rcy=(int *)malloc(fm*sizeof(int));
				int fxn=fx[n],fyn=fy[n];
				for (i=0;i<fm;i++) {joined[i]=(i==n); rcx[i]=rcy[i]=0;}
				while (going) // Find what's joined to it
				{
					going=0;
					for (i=0;i<fm;i++) if (joined[i])
					{
						int u=fc[i][0],r=fc[i][1],d=fc[i][2],l=fc[i][3];
						if (u>=0 && !joined[u]) {joined[u]=1; rcx[u]=rcx[i]; rcy[u]=rcy[i]-1; going=1;}
						if (r>=0 && !joined[r]) {joined[r]=1; rcx[r]=rcx[i]+1; rcy[r]=rcy[i]; going=1;}
						if (d>=0 && !joined[d]) {joined[d]=1; rcx[d]=rcx[i]; rcy[d]=rcy[i]+1; going=1;}
						if (l>=0 && !joined[l]) {joined[l]=1; rcx[l]=rcx[i]-1; rcy[l]=rcy[i]; going=1;}
					}
				}
				for (i=0;i<fm;i++) if (joined[i]) // Squares reenter the grid
				{
					grid[x=fxn+rcx[i]][y=fyn+rcy[i]]=ft[i];
					conx[x][y]=(fc[i][0]>=0)+(fc[i][1]>=0)*2+(fc[i][2]>=0)*4+(fc[i][3]>=0)*8;
					plotsquare(x,y,ft[i],conx[x][y]);
				}
				for (i=0;i<fm;i++) if (joined[i]) // Remove squares from fall buffer
				{
					fm--;
					fx[i]=fx[fm]; fy[i]=fy[fm]; ft[i]=ft[fm];
					ff[i]=ff[fm]; ffs[i]=ffs[fm];
					for (j=0;j<fm;j++) for (k=0;k<4;k++)
					{
						if (fc[j][k]==i) fc[j][k]=-1;
						else if (fc[j][k]==fm) fc[j][k]=i;
					}
					for (j=0;j<4;j++) fc[i][j]=fc[fm][j];
					joined[i]=joined[fm];
					i--;
				}
				free(joined); free(rcx); free(rcy);
			}
			else
			{
				fy[n]++;
				ff[n]+=16;
			}
			n=-1;
		}
		for (n=0;n<fm;n++) // (4 of 4)
			if (fy[n]>=10) mskbit(fx[n]*16,(fy[n]-10)*16-ff[n],squ[ft[n]]);
		for participants(p) // Each player's block
		{
			char ok=0;
			for (x=0;x<9;x++) for (y=0;y<9;y++) if (i=block[p][x][y])
			{
				int rx=px[p]+x,ry=py[p]+y;
				if (rx>=0 && rx<40 && ry>=10 && ry<40)
					mskbit(rx*16,(ry-10)*16-fall[p],squ[i]);
				ok=1;
			}
			if (!ok) // Produce a new block
			{
				block[p][4][4]=1;
				i=minsize+rnd(maxsize-minsize+1);
				for (n=1;n<i;)
				{
					do {x=1+rnd(7); y=1+rnd(7);} while (block[p][x][y]);
					if (block[p][x+1][y] || block[p][x-1][y] ||
						block[p][x][y+1] || block[p][x][y-1]) {block[p][x][y]=1; n++;}
				}
				for (x=0;x<9;x++) for (y=0;y<9;y++) if (block[p][x][y]==1) // Bevel it
				{
					block[p][x][y]+=(block[p][x][y-1]==0)+2*(block[p][x+1][y]==0)+
						4*(block[p][x][y+1]==0)+8*(block[p][x-1][y]==0);
//					if (!rnd(10)) block[p][x][y]=17+rnd(4);
//					if (frnd(1)<cp) block[p][x][y]=22+(int)(frnd(4)*frnd(2));
				}
				// Center block
				{
					int block2[9][9],ax=0,ay=0,a=0;
					for (x=0;x<9;x++) for (y=0;y<9;y++) if (block[p][x][y])
					{
						ax+=x; ay+=y; a++;
					}
					ax=(ax+a/2)/a; ay=(ay+a/2)/a;
					for (x=0;x<9;x++) for (y=0;y<9;y++)
					{
						int nx=(x-ax+4+9)%9,ny=(y-ay+4+9)%9;
						block2[nx][ny]=block[p][x][y];
					}
					for (x=0;x<9;x++) for (y=0;y<9;y++)
						block[p][x][y]=block2[x][y];
				}
			}
		}
		for (n=0;n<em;n++) // Dust loop
		{
			ex[n]+=exs[n]*dt; ey[n]+=eys[n]*dt;
			exs[n]*=pow(1.03,dt); eys[n]*=pow(1.03,dt);
			putpix(ex[n],ey[n],ec[n]);
			if (ex[n]<0 || ex[n]>=xres || ey[n]<0 || ey[n]>=yres)
			{
				em--;
				ex[n]=ex[em]; ey[n]=ey[em];
				exs[n]=exs[em]; eys[n]=eys[em];
				ec[n]=ec[em];
				n--;
			}
		}
		for (n=0;n<vm;n++) // Visual effects loop
		{
			if (vt[n]/4==0) // Horizontal dissolve
				for (x=vx[n]*16;x<(vx[n]+vxs[n])*16;x++)
				{
					float p=(float)(x-vx[n]*16)/(vxs[n]*16),q=1.0-p;
					int c1=256,c2=256;
					i=fabs(12.0-vs[n]+p*20); j=fabs(12.0-vs[n]+q*20);
					if (i<=12) c1=player_colours[vt[n]%4][i];
					if (j<=12) c2=player_colours[vt[n]%4][j];
					for (y=(vy[n]-10)*16;y<(vy[n]-10+vys[n])*16;y+=2)
						{if (c1<256) putpix(x,y,c1); if (c2<256) putpix(x,y+1,c2);}
				}
			else if (vt[n]/4==1) // Vertical dissolve
				for (y=(vy[n]-10)*16;y<(vy[n]-10+vys[n])*16;y++)
				{
					float p=(float)(y-(vy[n]-10)*16)/(vys[n]*16),q=1.0-p;
					int c1=256,c2=256;
					i=fabs(12.0-vs[n]+p*20); j=fabs(12.0-vs[n]+q*20);
					if (i<=12) c1=player_colours[vt[n]%4][i];
					if (j<=12) c2=player_colours[vt[n]%4][j];
					for (x=vx[n]*16;x<(vx[n]+vxs[n])*16;x+=2)
						{if (c1<256) putpix(x,y,c1); if (c2<256) putpix(x+1,y,c2);}
				}
			vs[n]--;
			if (vs[n]<=0) // Effect finished
			{
				vm--;
				vx[n]=vx[vm]; vy[n]=vy[vm]; vxs[n]=vxs[vm];
				vs[n]=vs[vm]; vt[n]=vt[vm];
				n--;
			}
		}
		for participants(p)
		{
			if (KEY(leftkey[p])) // Left
			{
				char ok=1;
				leftagain:;
				for (x=0;x<9;x++) for (y=0;y<9;y++)
				{
					int rx=px[p]+x,ry=py[p]+y;
					if (rx-1>=0 && rx-1<40 && ry>=0 && ry<40)
						if (block[p][x][y] && grid[rx-1][ry]) ok=0;
					if (fall[p]>1+grav+5*KEY(downkey[p]))
						if (rx-1>=0 && rx-1<40 && ry-1>=0 && ry-1<40)
							if (block[p][x][y] && grid[rx-1][ry-1]) ok=0;
				}
				if (ok && KEY(upkey[p]))
					{px[p]--; ncgisound((px[p]+4)*16+8,n_side,250,11025,0); goto leftagain;}
				if (ok && !ldelay[p])
					{px[p]--; ldelay[p]=10; ncgisound((px[p]+4)*16+8,n_side,250,11025,0);}
			}
			else ldelay[p]=0;
			if (KEY(rightkey[p])) // Right
			{
				char ok=1;
				rightagain:;
				for (x=0;x<9;x++) for (y=0;y<9;y++)
				{
					int rx=px[p]+x,ry=py[p]+y;
					if (rx+1>=0 && rx+1<40 && ry>=0 && ry<40)
						if (block[p][x][y] && grid[rx+1][ry]) ok=0;
					if (fall[p]>1+grav+5*KEY(downkey[p]))
						if (rx+1>=0 && rx+1<40 && ry-1>=0 && ry-1<40)
							if (block[p][x][y] && grid[rx+1][ry-1]) ok=0;
				}
				if (ok && KEY(upkey[p]))
					{px[p]++; ncgisound((px[p]+4)*16+8,n_side,250,11025,0); goto rightagain;}
				if (ok && !rdelay[p])
					{px[p]++; rdelay[p]=10; ncgisound((px[p]+4)*16+8,n_side,250,11025,0);}
			}
			else rdelay[p]=0;
			if (KEY(firekey[p])) // Rotate
			{
				int rblock[9][9];
				char ok=1;
				for (x=0;x<9;x++) for (y=0;y<9;y++)
					rblock[x][y]=block[p][y][8-x];
				for (x=0;x<9;x++) for (y=0;y<9;y++)
				{
					int rx=px[p]+x,ry=py[p]+y;
					if (rx>=0 && rx<40 && ry>=0 && ry<40)
						if (rblock[x][y] && grid[rx][ry]) ok=0;
					if (fall[p]>1+grav+5*KEY(downkey[p]))
						if (rx>=0 && rx<40 && ry-1>=0 && ry-1<40)
							if (rblock[x][y] && grid[rx][ry-1]) ok=0;
				}
				if (ok && !rotdelay[p])
				{
					for (x=0;x<9;x++) for (y=0;y<9;y++)
					{
						i=block[p][x][y]=rblock[x][y];
						if (i>=1 && i<=16)
						{
							i=(i-1)*2;
							if (i&16) i-=15;
							block[p][x][y]=i+1;
						}
						else if (i>=17 && i<=20) block[p][x][y]=(i-16)%4+17;
					}
					ncgisound((px[p]+4)*16+8,n_rotate,3000,11025,0);
					rotdelay[p]=25;
				}
			}
			else rotdelay[p]=0;
			if (ldelay[p]>0) ldelay[p]--; if (rdelay[p]>0) rdelay[p]--;
			if (rotdelay[p]>0) rotdelay[p]--;
			if (KEY(downkey[p])) fall[p]-=5*dt; // Drop
			fall[p]-=grav*dt;
			if (fall[p]<0) // Check for landing
			{
				char landed=0;
				for (x=0;x<9;x++) for (y=0;y<9;y++)
				{
					int rx=px[p]+x,ry=py[p]+y;
					if (rx>=0 && rx<40 && ry+1>=0 && ry+1<40)
						if (block[p][x][y] && grid[rx][ry+1]) landed=1;
				}
				if (landed)
				{
					ncgisound((px[p]+4)*16+8,n_land,2000,11025,0);
					if (!fm) cp=p;
					for (x=0;x<9;x++) for (y=0;y<9;y++) if (block[p][x][y]) // Block lands
					{
						int rx=px[p]+x,ry=py[p]+y;
						if (ry<10) ret=Fail;
						grid[rx][ry]=block[p][x][y];
						conx[rx][ry]=0;
						if (y>0) if (block[p][x][y-1]) conx[rx][ry]+=1;
						if (x<8) if (block[p][x+1][y]) conx[rx][ry]+=2;
						if (y<8) if (block[p][x][y+1]) conx[rx][ry]+=4;
						if (x>0) if (block[p][x-1][y]) conx[rx][ry]+=8;
						plotsquare(rx,ry,grid[rx][ry],conx[rx][ry]);
					}
					for (x=0;x<9;x++) for (y=0;y<9;y++)
						block[p][x][y]=0; // Destroy block so that it is regenerated
					px[p]=findroom(grid,px[p]); py[p]=0; fall[p]=16;
				}
				else // Block falls one whole square without incident
				{
					fall[p]=noneg(fall[p]+16);
					py[p]++;
				}
			}
		}
		// Pattern detection
		{
			char flag[40][40];
			for (x=0;x<40;x++) for (y=0;y<40;y++) flag[x][y]=0;
			for (x=1;x<39;x++) for (y=1;y<39;y++) if (i=grid[x][y],(i>=22 && i<=29))
			{
				int value[8]={4,7,10,15,20,30,60,200},vi=value[i-22]*redbonus[cp];
				if (grid[x-1][y]==i && grid[x+1][y]==i) // Horizontal row
					{flag[x-1][y]=flag[x][y]=flag[x+1][y]=2; score[cp]+=vi*2; ncgisound(x*16+8,n_match,3000,11025,0);}
				if (grid[x][y-1]==i && grid[x][y+1]==i) // Vertical column
					{flag[x][y-1]=flag[x][y]=flag[x][y+1]=2; score[cp]+=vi; ncgisound(x*16+8,n_match,3000,11025,0);}
				if (grid[x-1][y-1]==i && grid[x+1][y+1]==i) // Downwards diagonal
					{flag[x-1][y-1]=flag[x][y]=flag[x+1][y+1]=2; score[cp]+=vi*3; ncgisound(x*16+8,n_match,3000,11025,0);}
				if (grid[x-1][y+1]==i && grid[x+1][y-1]==i) // Upwards diagonal
					{flag[x-1][y+1]=flag[x][y]=flag[x+1][y-1]=2; score[cp]+=vi*3; ncgisound(x*16+8,n_match,3000,11025,0);}
			}
			for (y=0;y<40;y++) // Horizontal green arrows
			{
				i=j=-1;
				for (x=0;x<40;x++)
				{
					k=grid[x][y];
					if (i>=0 && (k==0 || k==21 || x==39))
					{
						if (j>=0)
						{
							for (n=i+1;n<j;n++) flag[n][y]=1;
							score[cp]+=(j-i-1)*5;
							if (vm<vmax)
							{
								vx[vm]=i+1; vxs[vm]=j-i-1;
								vy[vm]=y; vys[vm]=1;
								vt[vm]=cp; vs[vm]=22;
								vm++;
							}
							j=-1;
						}
						i=-1;
					}
					if (i>=0 && k==19) j=x;
					if (i==-1 && k==17) {i=x; j=-1;}
				}
			}
			for (x=0;x<40;x++) // Vertical green arrows
			{
				i=j=-1;
				for (y=0;y<40;y++)
				{
					k=grid[x][y];
					if (i>=0 && (k==0 || k==21 || y==39))
					{
						if (j>=0)
						{
							for (n=i+1;n<j;n++) flag[x][n]=1;
							score[cp]+=(j-i-1)*5;
							if (vm<vmax)
							{
								vx[vm]=x; vxs[vm]=1;
								vy[vm]=i+1; vys[vm]=j-i-1;
								vt[vm]=4+cp; vs[vm]=22;
								vm++;
							}
							j=-1;
						}
						i=-1;
					}
					if (i>=0 && k==20) j=y;
					if (i==-1 && k==18) {i=y; j=-1;}
				}
			}
			for (x=0;x<40;x++) for (y=0;y<40;y++) if (flag[x][y]) // Vapourise blocks
			{
				int xx,yy;
				if (flag[x][y]==2) for (xx=0;xx<16;xx++) for (yy=0;yy<16;yy++)
				{
					if (em<emax) {n=em; em++;}
						else n=rnd(emax);
					ex[n]=x*16+xx; ey[n]=(y-10)*16+yy;
					do {exs[n]=frnd(3)-1.5; eys[n]=frnd(3)-1.5;}
					while (sq(exs[n])+sq(eys[n])>2);
					ec[n]=getpixb(ex[n],ey[n]);
				}
				grid[x][y]=0; got++;
				if (y<39) conx[x][y+1]&=14;
				if (x>0) conx[x-1][y]&=13;
				if (y>0) conx[x][y-1]&=11;
				if (x<39) conx[x+1][y]&=7;
				clearbgsquare(x,y);
			}
		}
		// Start-falling algorithm
		{
			char flag[40][40];
			int *ax=(int *)malloc(1600*sizeof(int)),*ay=(int *)malloc(1600*sizeof(int)),am;
			for (x=0;x<40;x++) for (y=0;y<40;y++) flag[x][y]=0;
			for (x=0;x<40;x++) for (y=0;y<40;y++) if (!flag[x][y]) // Scan all squares on screen
			{
				if (grid[x][y]==0 || grid[x][y]==21) flag[x][y]=2;
				else
				{
					int xx,yy;
					char going=1,supported=0;
					ax[0]=x; ay[0]=y; am=1;
					flag[x][y]=1;
					while (going)
					{
						going=0;
						for (n=0;n<am;n++)
						{
							xx=ax[n]; yy=ay[n];
							if (yy>0) if ((conx[xx][yy]&1) && !flag[xx][yy-1])
								{flag[xx][yy-1]=1; ax[am]=xx; ay[am]=yy-1; am++; going=1;}
							if (xx<39) if ((conx[xx][yy]&2) && !flag[xx+1][yy])
								{flag[xx+1][yy]=1; ax[am]=xx+1; ay[am]=yy; am++; going=1;}
							if (yy<39) if ((conx[xx][yy]&4) && !flag[xx][yy+1])
								{flag[xx][yy+1]=1; ax[am]=xx; ay[am]=yy+1; am++; going=1;}
							if (xx>0) if ((conx[xx][yy]&8) && !flag[xx-1][yy])
								{flag[xx-1][yy]=1; ax[am]=xx-1; ay[am]=yy; am++; going=1;}
						}
					}
					for (n=0;n<am;n++)
					{
						xx=ax[n]; yy=ay[n];
						if (grid[xx][yy+1] && flag[xx][yy+1]!=1) supported=1;
					}
					if (!supported) // Chunk starts falling
						for (xx=0;xx<40;xx++) for (yy=0;yy<40;yy++) if (flag[xx][yy]==1)
						{
							fx[fm]=xx; fy[fm]=yy; ft[fm]=grid[xx][yy];
							ff[fm]=ffs[fm]=0;
							for (n=0;n<4;n++) fc[fm][n]=-1;
							for (n=0;n<fm;n++) if (flag[fx[n]][fy[n]]==1)
							{
								if (fx[n]==fx[fm] && fy[n]==fy[fm]-1) {fc[fm][0]=n; fc[n][2]=fm;}
								if (fx[n]==fx[fm]-1 && fy[n]==fy[fm]) {fc[fm][3]=n; fc[n][1]=fm;}
							}
							fm++;
							grid[xx][yy]=0;
							clearbgsquare(xx,yy);
							if (yy>=10) wrapbit(xx*16,(yy-10)*16,squ[ft[fm-1]]);
						}
					for (n=0;n<am;n++) flag[ax[n]][ay[n]]=2;
				}
			}
			free(ax); free(ay);
		}
		got=Min(got,complete);
		// Display blocks destroyed
		{
			float p1=(float)got/pass,p2=(float)(got-pass)/(complete-pass);
			blackbox(495,395,580-495,425-395);
			if (got>=pass)
			{
				strcpy(str,"Level passed");
				write(536,400,xres,str,16,0);
				write(534,400,xres,str,16,0);
				write(535,401,xres,str,16,0);
				write(535,399,xres,str,16,0);
				write(535,400,xres,str,15,7);
				sprintf(str,"%d",got);
			}
			else sprintf(str,"%d / %d",got,pass);
			write(499,400,xres,str,16,0);
			write(500,399,xres,str,16,0);
			write(500,401,xres,str,16,0);
			write(501,400,xres,str,16,0);
			write(500,400,xres,str,15,7);
			p1*=25; p2*=25;
			if (pass<=25) p1=floor(p1);
			if (complete-pass<=25) p2=floor(p2);
			for (x=500;x<575;x+=3)
			{
				float led=(x-500)/3;
				if (led>p1) rect(x,410,2,10,1);
				else if (led+1>p1)
				{
					rect(x,410,2,10,1);
					rect(x,410,2,10.0*(p1-floor(p1)),238);
				}
				else if (led>p2) rect(x,410,2,10,238);
				else if (led+1>p2)
				{
					rect(x,410,2,10,238);
					rect(x,410,2,10.0*(p2-floor(p2)),250);
				}
				else rect(x,410,2,10,250);
			}
		}
		if (got>=complete) // Finished level!
		{
			clevel++;
			calclevelC(&levq,&levrep);
			goto begin_C_level;
		}
		if (level_readout) // Level introduction
		{
			float h;
			n=Min(xres/3,Min(level_readout*5,(300-level_readout)*5));
			h=(1.0-exp(n*-0.03))*25;
			bluebox(xres/2-n,yres/2+5-h,n*2,h*2);
			if (n>=80)
			{
				sprintf(str,"Level C%d",clevel);
				strlwr(str);
				if (300-level_readout<18) strbound(str,300-level_readout+40);
				else if (300-level_readout<44) strbound(str,300-level_readout-18+'a');
				bwrite(xres/2-4.5*strlen(str),yres/2-4,xres,str,(level_readout>150)?238:1+level_readout/10%2*237);
				if (levrep) sprintf(str,"%s %d",subtitle[levq-1],levrep+1);
					else strcpy(str,subtitle[levq-1]);
				strlwr(str);
				if (300-level_readout<18) strbound(str,300-level_readout+40);
				else if (300-level_readout<44) strbound(str,300-level_readout-18+'a');
				write(xres/2-0.5*estlength(str),yres/2+10,xres,str,250,238);
			}
			level_readout-=(int)(dt+0.5);
			if (level_readout<0) level_readout=0;
		}
		dispscores(them,score);
		cclb();
		// Frame-sync
		do	if (dealwithmessages()) return Error;
		while (GetTickCount()<framestart+mswait);
		dt=((double)GetTickCount()-framestart)/mswait;
	}
	freesoundsC();
	for (n=0;n<=21;n++) free(squ[n]);
	free(fx); free(fy); free(ft); free(ff); free(ffs);
	for (n=0;n<fmax;n++) free(fc[n]); free(fc);
	for (x=0;x<40;x++) free(conx[x]); free(conx);
	return ret; // 0=Fail 1=Pass 2=Quit 3=Error
}
