/* Subgame N: Particles */

void infoscreenN()
{
	if (seeninfo['N']) return;
	seeninfo['N']=1;
	titlepal(gamma);
	memset(shad,0,40*xres);
	memset(shad+40*xres,160,400*xres);
	memset(shad+440*xres,0,40*xres);
	bwrite(60,60,xres,"Subgame N:",15);
	bwrite(60,80,xres,"''Particles''",200);
	write(60,100,xres/2-60,"Objective",0,1);
	write(60,110,xres/2-60,"Catch as many balls as you can.",15,200);
	write(60,120,xres/2-60,"Risks",0,1);
	write(60,130,xres/2-60,"If you fail to catch a red ball, you will exit \
the subgame and may also lose a life if you have not collected enough balls.  In \
addition, all the other balls will shift in colour towards the red end of the spectrum \
if you fail to catch them.  On later levels, there are also many undocumented and \
potentially hazardous special features to be aware of.",15,200);
	write(60,170,xres/2-60,"Rewards",0,1);
	write(60,180,xres/2-60,"You score points for collecting balls.  The \
further away from the red end of the spectrum a ball is, the more points it is \
worth.  There are more bonus points available on completion of a level, including \
special extra points for collecting balls in certain colour sequences.",15,200);
	write(60,220,xres/2-60,"Expect the unexpected.",15,200);
	ccl(0); Sleep(500);
	while (!kbhit && !dealwithmessages());
	writepal(gamma);
}

void calclevelN(int *q,int *r)
{
	int n,i,j,*a=(int *)malloc((nlevel+1)*sizeof(int)),p[26];
	for (n=1;n<=nlevel;n++) a[n]=0;
	for (n=1;n<=25;n++) p[n]=625/(26-n)-24;
	for (n=25;n>=1;n--)
	{
		j=0;
		for (i=1;i<=nlevel;i++)
		{
			if (!a[i]) j++;
			if (j==p[n]) {a[i]=n; j=0;}
		}
	}
	i=a[nlevel]; j=0;
	for (n=1;n<nlevel;n++) j+=(a[n]==i);
	*q=i; *r=j;
}

void passed_sound()
{
	int n;
	unsigned char *s=(unsigned char *)malloc(25000);
	if (!sound_working) return;
	s[0]=128;
	for (n=1;n<25000;n++)
	{
		float p=exp(-0.0002*n),q=1.0-p,r=exp(-0.0005*(25000-n));
		s[n]=(1.0-r)*(q*s[n-1]+p*rnd(256))+r*128;
	}
	n=findfree(0);
	stopsound(soundchannel[n]); killbuffer(soundchannel[n]);
	soundchannel[n]=makebuffer(25000,5000);
	writesound(s,soundchannel[n],25000);
	playsound(soundchannel[n]);
}

void levelbonusN(const int them,const char history[MAXP][5000])
{
	int p,n,i,j,k;
	char str[100];
	unsigned char *ball[10];
	for (n=0;n<10;n++) // Make ball sprites
	{
		char c=40+n*2,px,py;
		ball[n]=(unsigned char *)malloc(102);
		ball[n][0]=ball[n][1]=10;
		for (px=0;px<10;px++)
			for (py=0;py<10;py++)
			{
				i=fabs(4.5-px)+fabs(4.5-py);
				if (i<7) ball[n][2+px+py*10]=c;
				else if (i>7) ball[n][2+px+py*10]=255;
				else ball[n][2+px+py*10]=c+72;
			}
		ball[n][5]=ball[n][8]=ball[n][95]=ball[n][98]=c+72;
		ball[n][32]=ball[n][41]=ball[n][62]=ball[n][71]=c+72;
	}
	for participants(p) // Per player
	{
		char runstart[1667],runinc[1667],runlength[1667],
			  cstart,cinc,clength;
		int value[1667];
		for (n=0;n<xres/2-25;n+=10) // Box expands
		{
			double framestart=GetTickCount();
			blackbox(xres/2-n,100,n*2,yres-100-25);
			dispscores(them,score);
			cclb();
			while (GetTickCount()<framestart+mswait) if (dealwithmessages()) return;
		}
		i=0;
		if (history[p][3]) for (n=1;n<5000 && history[p][n];n++)
		{
			char this=history[p][n],last=history[p][n-1],next=history[p][n+1]*(n+1<5000);
			if (this-last==cinc) clength++;
			if (n==1 || this-last!=cinc || !next) // Start a new run
			{
				if (n!=1 && clength>=4 && abs(cinc)<=1) // Save old run
				{
					runstart[i]=cstart;
					runinc[i]=cinc;
					runlength[i]=clength;
					if (cinc==0) // Same-colour run
					{
						if (clength==4) value[i]=250;
						else if (clength==5) value[i]=500;
						else if (clength==6) value[i]=1000;
						else if (clength>=7) value[i]=2000*(clength-6);
						if (nlevel%25==2 || nlevel%25==3 || nlevel%25==10 || nlevel%25==23) value[i]/=10;
					}
					else // Ascending/descending
					{
						if (clength==4) value[i]=400;
						else if (clength==5) value[i]=1250;
						else if (clength==6) value[i]=5000;
						else if (clength==7) value[i]=25000;
						else if (clength==8) value[i]=150000;
						else if (clength==9) value[i]=1000000;
						else if (clength==10) value[i]=8000000;
					}
					value[i]*=(nlevel-1)/25+1;
					i++;
				}
				cstart=last;
				cinc=this-last;
				clength=2;
			}
		}
		for (n=0;n<i;n++) // Per run
		{
			int isc=score[p],steps;
			for (j=(n)?0:20;j<=20;j+=2) // Scrolling between
			{
				double framestart=GetTickCount();
				blackbox(25,100,xres-50,yres-100-25);
				for (k=n;k<i && k<n+13;k++) // Visible runs
				{
					int py=150+(k-n)*20+20-j,b,px;
					line(50,py,50,py+13,7);
					line(50,py,53,py,7);
					line(50,py+13,53,py+13,7);
					for (b=0;b<runlength[k];b++)
						wrapbit(55+b*12,py+2,ball[runstart[k]+b*runinc[k]-1]);
					px=54+runlength[k]*12;
					line(px+3,py,px+3,py+13,7);
					line(px,py,px+3,py,7);
					line(px,py+13,px+3,py+13,7);
					numplot(xres-100,py,0,p,value[k]);
				}
				if (them==1) sprintf(str,"Level N%d bonus",nlevel);
					else sprintf(str,"Level N%d bonus / Player %d",nlevel,p+1);
				bwrite(50,125,xres,str,15);
				dispscores(them,score);
				cclb();
				while (GetTickCount()<framestart+((n)?mswait:1500+Min(i,10)*150))
					if (dealwithmessages()) return;
			}
			steps=Min(value[n]/3,43);
			for (j=0;j<steps;j++) // Score addition
			{
				double framestart=GetTickCount();
				blackbox(25,100,xres-50,yres-100-25);
				for (k=n;k<i && k<n+13;k++) // Visible runs
				{
					int py=150+(k-n)*20,b,px;
					line(50,py,50,py+13,7);
					line(50,py,53,py,7);
					line(50,py+13,53,py+13,7);
					for (b=0;b<runlength[k];b++)
						wrapbit(55+b*12,py+2,ball[runstart[k]+b*runinc[k]-1]);
					px=54+runlength[k]*12;
					line(px+3,py,px+3,py+13,7);
					line(px,py,px+3,py,7);
					line(px,py+13,px+3,py+13,7);
					numplot(xres-100,py,0,p,(k==n)?(float)value[n]*(steps-j)/steps:value[k]);
				}
				if (them==1) sprintf(str,"Level N%d bonus",nlevel);
					else sprintf(str,"Level N%d bonus / Player %d",nlevel,p+1);
				bwrite(50,125,xres,str,15);
				score[p]=isc+(float)value[n]*j/steps;
				dispscores(them,score);
				cclb();
				while (GetTickCount()<framestart+mswait) if (dealwithmessages()) return;
			}
			score[p]=isc+value[n];
		}
		for (n=xres/2-25;n>0;n-=10) // Box contracts
		{
			double framestart=GetTickCount();
			blackbox(xres/2-n,100,n*2,yres-100-25);
			dispscores(them,score);
			cclb();
			while (GetTickCount()<framestart+mswait) if (dealwithmessages()) return;
		}
	}
}

enum sg_retcode subgameN(const int them) /* Particles Resurrection */
{
	int n,i,p,px,py;
	char str[100];
	float fp[20];
	char *subtitle[25]={"Normality","Overload","Rain","Breezy Day","Weird Orbit",
							  "Blackout Zone","Sludge Filter","Popcorn","Repulsion","No Mistakes",
							  "Polarity Reversed","Eternity","Jupiter","Asteroid Field","New Colours",
							  "Pinball Bumper","Binary System","Faster...","Hypersource","The Unexpected",
							  "The Storm","Rainbow","Fission","Traffic Lights","The final remix"};
	float *bx=FXP,*bxs=FXP,*brad=FXP; char *bh=CXP; // Players' bats
	int *brec=IXP;
	int max=5000,m=0; // Particles
	float *x=(float *)malloc(max*sizeof(float)),*y=(float *)malloc(max*sizeof(float)),
		*xs=(float *)malloc(max*sizeof(float)),*ys=(float *)malloc(max*sizeof(float));
	int *s=(int *)malloc(max*sizeof(int)),*t=(int *)malloc(max*sizeof(int));
	int emax=500,em=0;
	float *ex=(float *)malloc(emax*sizeof(float)),*ey=(float *)malloc(emax*sizeof(float)),
		*er=(float *)malloc(emax*sizeof(float));
	unsigned char *ball[10];
	char history[MAXP][5000];
	int got[MAXP+1]={0,0,0,0,0},left=1,lpass=1; // Counters
	int pass[25]={100,100,120,75,100,100,100,100,75,15,
			100,600,150,120,120,120,150,200,100,200,150,150,250,200,300},
		total[25]={250,300,350,250,400,300,350,300,300,50,
			300,1600,400,350,350,300,400,500,300,600,400,400,500,500,500};
	float grav=8,rate=20; int lowcolour=2,highcolour=5,multi=1;
	int startlevel=nlevel;
	int levq,levrep;
	char dispsource=1,level_start=1;
	int level_readout=300;
	unsigned char batcolour[4]={10,54,11,14};
	unsigned char *cloudel=(unsigned char *)malloc(2+40*40),
		*cloud=(unsigned char *)malloc(2+200*120),
		*mine=(unsigned char *)malloc(2+12*12);
	unsigned char *note=(unsigned char *)malloc(5000);
	int scale[11]={0,-9,-7,-5,-4,-2,0,2,3,5,7};
	float dt=1,lastcatch=0;
	char leave=0;
	infoscreenN();
	calclevelN(&levq,&levrep);
	for (n=0;n<10;n++) // Make ball sprites
	{
		char c=40+n*2;
		ball[n]=(unsigned char *)malloc(102);
		ball[n][0]=ball[n][1]=10;
		for (px=0;px<10;px++)
			for (py=0;py<10;py++)
			{
				i=fabs(4.5-px)+fabs(4.5-py);
				if (i<7) ball[n][2+px+py*10]=c;
				else if (i>7) ball[n][2+px+py*10]=255;
				else ball[n][2+px+py*10]=c+72;
			}
		ball[n][5]=ball[n][8]=ball[n][95]=ball[n][98]=c+72;
		ball[n][32]=ball[n][41]=ball[n][62]=ball[n][71]=c+72;
	}
	cloudel[0]=cloudel[1]=40; // Cloud element sprite
	for (px=0;px<40;px++) for (py=0;py<40;py++)
	{
		float f=0.0025*(400-sq(px-20)-sq(py-20));
		if (frnd(1)<f) cloudel[2+px+py*40]=0.1*(px+py)+24;
			else cloudel[2+px+py*40]=255;
	}
	memset(shad,0,xres*yres);
	for (n=0;n<100;n++)
	{
		float rad=sqrt(frnd(sq(80))),th=frnd(M_PI*2);
		mskbit(80+rad*sin(th),40+rad*0.5*cos(th),cloudel);
	}
	cloud[0]=200; cloud[1]=120; // Record cloud sprite
	for (px=0;px<200;px++) for (py=0;py<120;py++)
	{
		unsigned char c=getpix(px,py);
		cloud[2+px+py*200]=(c)?c:255;
	}
	for (px=0;px<40;px++) for (py=0;py<40;py++) // Becomes rock sprite
	{
		float f=24+7*0.0025*(400-sq(px-20)-sq(py-20));
		if (f>=24) cloudel[2+px+py*40]=f+frnd(1);
			else cloudel[2+px+py*40]=255;
	}
	readbit(mine,".\\ncgi.dat",667);
	for (n=0;n<5000;n++) note[n]=128.0+(1.0-exp(-0.01*n))*0.025*(5000-n)*sin(0.1*n);
	for participants(p) // Players initialisation
	{
		bx[p]=xres/2; bxs[p]=0; bh[p]=1;
		brec[p]=0;
		brad[p]=xres/10;
		i=0;
		for (n=them;n;n>>=1) i+=n&1;
		brad[p]/=sqrt(i);
	}
	cl(0); clb(0);
	for (leave=0;!leave;) // <N> Main Loop
	{
		double time=0.001*GetTickCount();
		float sourcex=sin(time)*xres/3+xres/2,sourcey=yres/4;
		char ai_l=0,ai_r=0;
		if (dealwithmessages()) return Error;
		if (level_start)
		{
			memset(back,0,xres*yres);
			for participants(p)	for (n=0;n<5000;n++)
				history[p][n]=0;
			if (levq==13) // N13: Jupiter
			{
				memset(back+150*xres,44,80*xres);
				memset(back+230*xres,42,80*xres);
				memset(back+310*xres,40,80*xres);
				memset(back+390*xres,42,80*xres);
			}
			if (levq==14 || levq==25) // N14,25: Asteroid field
				for (n=0;n<10;n++)
				{
					fp[n*2]=frnd(xres-50)+25;
					fp[n*2+1]=frnd(yres-100)+25;
				}
			if (levq==22) // N22: Colour filters
			{
				rectb(10,yres/2,xres/4-20,yres/10,12);
				rectb(10+xres/4,yres/2,xres/4-20,yres/10,14);
				rectb(10+xres/2,yres/2,xres/4-20,yres/10,10);
				rectb(10+xres*3/4,yres/2,xres/4-20,yres/10,11);
			}
			level_start=0;
		}
		if (levq==4 || levq==21) // N4,21: Windy day
		{
			fp[1]=yres/2+sin(time)*yres/3;
			fp[2]=yres/2+sin(0.2*M_PI*time)*yres/3;
		}
		if (levq==5 || levq==21) // N5,21: Weird orbit
			sourcey=sin(2.0*time)*yres/4+yres/3;
		if (levq==7) // N7: Water, mud and walls [variables]
		{
			fp[1]=yres*3/4+sin(0.2*time)*yres/5;
			fp[2]=yres*3/4-sin(0.2*time)*yres/5;
		}
		if (levq==9) // N9: Repulsors
			for (n=0;n<3;n++)
			{
				fp[n*2]=xres/2+sin(0.1*time+n*M_PI*2/3)*xres/3;
				fp[n*2+1]=yres/2+sin(0.2*time+n*M_PI*2/3)*yres/3;
			}
		if (levq==17) // N17: Binary magnets
		{
			fp[0]=xres/2+sin(0.5*time)*xres/4;
			fp[1]=yres/2+cos(0.5*time)*yres/4;
			fp[2]=xres/2-sin(0.5*time)*xres/4;
			fp[3]=yres/2-cos(0.5*time)*yres/4;
		}
		if (levq==18 || levq==24) // N18,24: Faster...
		{
			sourcex=sin(2.0*time)*xres/3+xres/2;
			if (levq==24) fp[1]=xres/2+sin(time)*xres/3; // N24: Downward fan
		}
		if (levq==22) fp[1]=xres/2+sin(time)*xres/3; // N22: Vertical fan
		if (left && dispsource) for (n=0;n<8;n++) // Display Particle Source
		{
			float th=2.0*time+M_PI*n/4;
			if (levq==18 || levq==24) th=4.0*time+M_PI*n/4; // N18,24: Faster...
			if (levq==19 || levq==25) // N19,25: Hypersource
			{
				line(sourcex+20*cos(th),sourcey+20*sin(th),
						 sourcex+30*cos(th),sourcey+30*sin(th),3);
				th*=-1;
				putpix(sourcex+24*cos(th),sourcey+24*sin(th),11);
				th*=2;
				putpix(sourcex+18*cos(th),sourcey+18*sin(th),15);
			}
			else
			{
				line(sourcex+10*cos(th),sourcey+10*sin(th),
						 sourcex+15*cos(th),sourcey+15*sin(th),5);
				th*=-1;
				putpix(sourcex+12*cos(th),sourcey+12*sin(th),13);
				th*=2;
				putpix(sourcex+9*cos(th),sourcey+9*sin(th),15);
			}
		}
		if (levq==4 || levq==21) // N4,21: Windmills
		{
			float th;
			line(0,fp[1],yres/12,fp[1],7);
			line(xres-1,fp[2],xres-yres/12,fp[2],7);
			for (th=0;th<M_PI*1.9;th+=M_PI*2/3)
			{
				line(yres/12,fp[1],yres/12+sin(th+time*10)*yres/12,
						 fp[1]+cos(th+time*10)*yres/6,15);
				line(xres-yres/12,fp[2],xres-yres/12+sin(th+time*12)*yres/12,
						 fp[2]+cos(th+time*12)*yres/6,15);
			}
		}
		if (levq==7) // N7: Water, mud and walls
		{
			rect(0,fp[1],xres*9/20,yres-fp[1],1);
			for (px=0;px<xres*9/20;px++)
				line(px,fp[1],px,fp[1]+sin(0.05*px+3.0*time)*yres/40,
						 (sin(0.05*px+3.0*time)<0));
			rect(xres*9/20,yres/2,xres/10,yres/2,7);
			rect(xres*11/20,fp[2],xres*9/20,yres-fp[2],141);
		}
		if (levq==9) // N9: Repulsors
			for (n=0;n<3;n++)
				for (i=0;i<50;i++)
				{
					float rad=frnd(20),th=frnd(M_PI*2);
					line(fp[n*2],fp[n*2+1],fp[n*2]+rad*cos(th),fp[n*2+1]+rad*sin(th),248+rnd(5));
				}
		if (levq==14 || levq==25) // N14,25: Asteroids
		{
			if (time-lastcatch>30) // Rejig on stagnation
			{
				for (n=0;n<10;n++)
				{
					fp[n*2]=frnd(xres-50)+25;
					fp[n*2+1]=frnd(yres-100)+25;
				}
				lastcatch=time;
			}
			for (n=0;n<10;n++)
				wrapbit(fp[n*2]-20,fp[n*2+1]-20,cloudel);
		}
		if (levq==15) // N15: Rotating gravity [arrow]
		{
			float xx=sin(time)*50,yy=cos(time)*50;
			line(xres/2-xx*2,yres/2-yy*2,xres/2+xx,yres/2+yy,2);
			line(xres/2+xx+yy,yres/2+yy-xx,xres/2+xx-yy,yres/2+yy+xx,2);
			line(xres/2+xx+yy,yres/2+yy-xx,xres/2+xx*2,yres/2+yy*2,2);
			line(xres/2+xx-yy,yres/2+yy+xx,xres/2+xx*2,yres/2+yy*2,2);
		}
		if (levq==16 || levq==25) // N16,25: Pinball bumper
		{
			float th;
			for (th=0;th<M_PI*2;th+=0.1)
				line(xres/2+sin(th)*30,yres/2+cos(th)*30,
						 xres/2+sin(th+0.1)*30,yres/2+cos(th+0.1)*30,9);
		}
		if (levq==17) // N17: Binary magnets
			for (n=0;n<2;n++)
				for (i=0;i<50;i++)
				{
					float rad=frnd(20),th=frnd(M_PI*2);
					line(fp[n*2],fp[n*2+1],fp[n*2]+rad*cos(th),fp[n*2+1]+rad*sin(th),142+rnd(3)*5);
				}
		if (levq==22) // N22: Vertical windmill
		{
			float th;
			line(fp[1],yres-1,fp[1],yres*11/12,7);
			for (th=0;th<M_PI*1.9;th+=M_PI*2/3)
				line(fp[1],yres*11/12,fp[1]+sin(th+time*10)*yres/6,
						 yres*11/12+cos(th+time*10)*yres/12,15);
		}
		if (levq==24) // N24: Downward windmill
		{
			float th;
			line(fp[1],0,fp[1],yres/12,7);
			for (th=0;th<M_PI*1.9;th+=M_PI*2/3)
				line(fp[1],yres/12,fp[1]+sin(th+time*10)*yres/6,
						 yres/12+cos(th+time*10)*yres/12,15);
		}
		for (n=0;n<em;n++) // Explosion effects
		{
			circlefill(ex[n],ey[n],er[n],4);
			circlefill(ex[n],ey[n],er[n]*3/4,12);
			circlefill(ex[n],ey[n],er[n]/2,14);
			circlefill(ex[n],ey[n],er[n]/4,15);
			er[n]--;
			if (er[n]<=0)
			{
				em--;
				ex[n]=ex[em]; ey[n]=ey[em]; er[n]=er[em];
			}
		}
		for (n=0;n<m;n++) // ** Plotting loop ** //
		{
			if (levq==6 && y[n]>yres*2/3) goto abort_plot; // N6: Blackout zone
			if (levq==24 && s[n]%2==0) goto abort_plot; // N24: Traffic lights
			if (t[n]==0)
			{
				if (levq==13) // N13: Jupiter
				{
					if (s[n]==1) {if (fabs(y[n]-350)<40) goto abort_plot;}
					else if (s[n]==2) {if (fabs(fabs(y[n]-350)-80)<40) goto abort_plot;}
					else if (s[n]==3) {if (fabs(y[n]-190)<40) goto abort_plot;}
				}
				if (levq==15) // N15: New colours
				{
					wrapbit(x[n]-5,y[n]-5,ball[10-s[n]]);
					goto abort_plot;
				}
				wrapbit(x[n]-5,y[n]-5,ball[s[n]-1]);
			}
			else if (t[n]==1)
			{
				wrapbit(x[n]-6,y[n]-6,mine);
			}
			else if (t[n]==2)
				for (i=0;i<8;i++)
				{
					float th=2.0*time+M_PI*i/4;
					line(x[n]+10*cos(th),y[n]+10*sin(th),
							 x[n]+15*cos(th),y[n]+15*sin(th),5);
					th*=-1;
					putpix(x[n]+12*cos(th),y[n]+12*sin(th),13);
					th*=2;
					putpix(x[n]+9*cos(th),y[n]+9*sin(th),15);
				}
			abort_plot:;
		}
		if (levq==21) // N21: Lightning
			if (!rnd(20)) memset(shad,11,xres*yres);
		if (levq==3 || levq==19 || levq==21 || levq==25) // N3,19,21,25: Clouds
			for (n=0;n<3;n++)
			{
				fp[n*2]=xres/2+sin((1.63+n*0.2)*(1e3+time/3))*xres/3;
				fp[n*2+1]=yres/2+sin((1.0+n*0.27)*(1e3+time/3))*yres/3;
				if (levq==3) mskbit(fp[n*2]-100,fp[n*2+1]-60,cloud);
				else if (levq==25)
				{
					if (n%2) wrapbitc(fp[n*2]-100,fp[n*2+1]-60,cloud,0);
					else wrapbit(fp[n*2]-100,fp[n*2+1]-60,cloud);
				}
				else wrapbitc(fp[n*2]-100,fp[n*2+1]-60,cloud,0);
			}
		for (n=0;n<m;n++) // ** Calculation loop ** //
		{
			float vr=5,mul=1;
			if (t[n]==1) vr=6;
			else if (t[n]==2) vr=15;
			if (levq==4 || levq==21) // N4,21: Windy day
			{
				if (fabs(y[n]-fp[1])<yres/6) xs[n]+=0.0002*(xres-x[n])*dt;
				if (fabs(y[n]-fp[2])<yres/6) xs[n]-=0.0002*x[n]*dt;
				if (fabs(xs[n])>5) xs[n]*=pow(0.99,dt);
			}
			if (levq==7) // N7: Water, mud and walls
			{
				float fx=fabs(x[n]-xres/2),fy=yres/2+xres/20-y[n];
				if (fx<xres/20+vr && fy<xres/20+vr)
				{
					if (fx>fy)
					{
						xs[n]=-xs[n];
						if (x[n]>xres/2) x[n]=xres*11/20+vr;
							else x[n]=xres*9/20-vr;
					}
					else {ys[n]=-ys[n]; y[n]=yres/2-vr-1;}
				}
				if (x[n]<xres*9/20 && y[n]>fp[1]+sin(0.05*x[n]+3.0*time)*yres/40) ys[n]-=0.25*dt;
				if (x[n]>xres*11/20 && y[n]>fp[2]) {xs[n]*=pow(0.98,dt); ys[n]*=pow(0.98,dt);}
			}
			if (levq==9) // N9: Repulsors
			{
				for (i=0;i<3;i++)
				{
					float dx=x[n]-fp[i*2],dy=y[n]-fp[i*2+1],dd=dx*dx+dy*dy+1;
					xs[n]+=5.0*dt*dx/dd; ys[n]+=5.0*dt*dy/dd;
				}
				if (sq(xs[n])+sq(ys[n])>sq(10)) {xs[n]*=pow(0.9,dt); ys[n]*=pow(0.9,dt);}
			}
			if (levq==14 || levq==25) // N14,25: Asteroid field
			{
				for (i=0;i<10;i++)
				{
					float dx=x[n]-fp[i*2],dy=y[n]-fp[i*2+1],dd=dx*dx+dy*dy;
					if (dd<sq(20+vr))
					{
						float oxs=xs[n];
						xs[n]-=(oxs*dx+ys[n]*dy)*dx*1.5/dd;
						ys[n]-=(oxs*dx+ys[n]*dy)*dy*1.5/dd;
						x[n]+=dx/sqrt(dd); y[n]+=dy/sqrt(dd);
					}
				}
			}
			if (levq==15) // N15: Rotating gravity
			{
				xs[n]+=0.08*sin(time)*dt;
				ys[n]+=0.08*cos(time)*dt;
				mul=0.8;
			}
			if (levq==16 || levq==25) // N16,25: Pinball bumper
			{
				float dx=x[n]-xres/2,dy=y[n]-yres/2;
				if (dx*dx+dy*dy<sq(30+vr))
				{
					xs[n]+=dx/3;
					ys[n]+=dy/3;
					if (t[n]==0 && s[n]<10) s[n]++;
					circlefill(xres/2,yres/2,25,13);
				}
			}
			if (levq==17) // N17: Binary gravity
			{
				for (i=0;i<2;i++)
				{
					float dx=x[n]-fp[i*2],dy=y[n]-fp[i*2+1],dd=dx*dx+dy*dy+1;
					xs[n]-=10.0*dt*dx/dd; ys[n]-=10.0*dt*dy/dd;
				}
				if (sq(xs[n])+sq(ys[n])>sq(10)) {xs[n]*=pow(0.9,dt); ys[n]*=pow(0.9,dt);}
			}
			if (levq==22) // N22: Vertical fan & colour filters
			{
				if (fabs(x[n]-fp[1])<yres/6) ys[n]-=0.0002*y[n]*dt;
				if (fabs(ys[n])>15) ys[n]*=pow(0.99,dt);
				for (i=0;i<4;i++)
					if (x[n]>i*xres/4+10 && x[n]<(i+1)*xres/4-10 &&
						 y[n]>yres/2 && y[n]<yres*3/5 && t[n]==0 && s[n]!=i*2+1)
					{
						int rx=x[n]-i*xres/4-xres/8,ry=y[n]-yres*11/20;
						if (fabs(rx)>fabs(ry)+xres/8-yres/20-10)
						{
							xs[n]=-xs[n];
							if (rx>0) x[n]=(i+1)*xres/4-9; else x[n]=i*xres/4+9;
						}
						else
						{
							ys[n]=-ys[n];
							if (ry>0) y[n]=yres*3/5+1; else y[n]=yres/2-1;
						}
					}
			}
			if (levq==23 && frnd(500)<dt*s[n] && m<max && left>0) // N23: Fission
			{
				float vx=frnd(1.2)-0.6,vy=frnd(1.2)-0.6;
				x[m]=x[n]; y[m]=y[n];
				xs[m]=xs[n]; ys[m]=ys[n];
				xs[n]+=vx; ys[n]+=vy;
				xs[m]-=vx; ys[m]-=vy;
				s[m]=s[n]; t[m]=t[n];
				if (y[n]<yres/2) {m++; left--;}
			}
			if (levq==24) // N24: Downward fan
			{
				if (fabs(x[n]-fp[1])<yres/6) ys[n]+=0.0002*(yres-y[n])*dt;
				if (fabs(ys[n])>15) ys[n]*=pow(0.99,dt);
			}
			ys[n]+=0.01*grav*dt;
			x[n]+=xs[n]*dt; y[n]+=ys[n]*dt;
			if (levq==16) // N16: Wrap
			{
				if (x[n]<0) x[n]+=xres;
				if (x[n]>xres) x[n]-=xres;
			}
			else // X walls
			{
				if (x[n]<vr) {x[n]=vr; xs[n]=-xs[n]*mul;}
				if (x[n]>xres-vr) {x[n]=xres-vr; xs[n]=-xs[n]*mul;}
			}
			if (y[n]<vr) {y[n]=vr; ys[n]=-ys[n]*mul;}
			if (y[n]>yres-vr) // Hits the floor
			{
				if (t[n]==0) // A normal particle
				{
					char caught=0;
					for participants(p) if (fabs(x[n]-bx[p])<brad[p]*bh[p])
					{
						score[p]+=s[n];
						history[p][got[p]++]=s[n];
						caught=1;
					}
					if (caught)
					{
						if (sound_working) // Sound effect
						{
							i=findfree(0);
							stopsound(soundchannel[i]); killbuffer(soundchannel[i]);
							soundchannel[i]=makebuffer(5000,pow(2,(float)scale[s[n]]/12)*440*62.83);
							writesound(note,soundchannel[i],5000);
							IDirectSoundBuffer_SetPan(soundchannel[i],(x[n]-xres/2)*STEREO);
							playsound(soundchannel[i]);
						}
						if (levq==20 || levq==25) // N20,25: Time reversal
							if (s[n]==3) for (i=0;i<m;i++)
							{
								xs[i]=-xs[i];
								ys[i]=-ys[i];
							}
						m--;
						x[n]=x[m]; y[n]=y[m];
						xs[n]=xs[m]; ys[n]=ys[m];
						s[n]=s[m]; t[n]=t[m];
						got[MAXP]++;
						if (got[MAXP]==lpass) passed_sound();
						lastcatch=time;
					}
					else
					{
						y[n]=yres-vr; ys[n]=-ys[n]*mul;
						s[n]--;
						if (s[n]<=0) // Dropped a red
						{
							m--;
							x[n]=x[m]; y[n]=y[m];
							xs[n]=xs[m]; ys[n]=ys[m];
							s[n]=s[m]; t[n]=t[m];
							leave=1;
						}
						else if (levq==20) s[n]=rnd(6)+1; // N20: Randomize colours
					}
				}
				else if (t[n]==1) // A mine/bomb thingy
				{
					char caught=0;
					for participants(p) if (fabs(x[n]-bx[p])<brad[p]*bh[p])
					{
						brec[p]=GetTickCount()+2500;
						caught=1;
					}
					if (!caught && em+10<=emax)
					{
						for (i=0;i<10;i++)
						{
							float rad=frnd(50),th=frnd(M_PI);
							ex[em+i]=x[n]+rad*cos(th);
							ey[em+i]=y[n]-rad*sin(th);
							er[em+i]=frnd(30);
						}
						em+=10;
					}
					m--;
					x[n]=x[m]; y[n]=y[m];
					xs[n]=xs[m]; ys[n]=ys[m];
					s[n]=s[m]; t[n]=t[m];
				}
				else if (t[n]==2) // A subsource
				{
					char caught=0;
					y[n]=yres-vr; ys[n]=-ys[n]*mul;
					for participants(p)
						if (fabs(x[n]-bx[p])<brad[p]*bh[p]) caught=1;
					if (caught || left<=0)
					{
						m--;
						x[n]=x[m]; y[n]=y[m];
						xs[n]=xs[m]; ys[n]=ys[m];
						s[n]=s[m]; t[n]=t[m];
					}
				}
			}
			if (t[n]==2) // Emission from subsource
				if (m<max && frnd(1)<0.001*rate*dt && left>0)
				{
					x[m]=x[n]; y[m]=y[n];
					do {xs[m]=frnd(5)-2.5; ys[m]=frnd(5)-2.5;}
					while (sq(xs[m])+sq(ys[m])>6.25);
					s[m]=s[n]; t[m]=0;
					m++; left--;
				}
		}
		for participants(p) // ** Players ** //
		{
			int x1=noneg(bx[p]-brad[p]),x2=bx[p]+brad[p];
			if (x2>xres-1) x2=xres-1;
			if (KEY(leftkey[p])) bxs[p]-=1.5*dt;
			if (KEY(rightkey[p])) bxs[p]+=1.5*dt;
			if (KEY(downkey[p])) bh[p]=0; else bh[p]=1;
			if (GetTickCount()<brec[p]) bh[p]=0;
			else
			{
				if (bh[p]) box(x1,yres-3-p,x2-x1,2+p,batcolour[p]);
				line(x1,yres-3-p,x1,yres-1,(p==1)?13:batcolour[p]);
				line(x2,yres-3-p,x2,yres-1,(p==1)?13:batcolour[p]);
			}
			bxs[p]*=pow(0.9,dt);
			bx[p]+=bxs[p]*dt;
			if (levq==11) bx[p]-=bxs[p]*2; // N11: Polarity reversed
			if (levq==16) // N16: Horizontal Wrap
			{
				if (bx[p]<0) bx[p]=xres;
				if (bx[p]>xres) bx[p]=0;
			}
			else
			{
				if (bx[p]<0) {bx[p]=0; bxs[p]*=-0.5;}
				if (bx[p]>xres) {bx[p]=xres; bxs[p]*=-0.5;}
			}
			if (them>=3 && them!=4 && them!=8) // Individual catch counters
			{
				sprintf(str,"#%d",got[p]);
				write(bx[p]+brad[p],yres-6*(p+1),xres,str,batcolour[p],0);
			}
		}
		if (frnd(1)<0.001*rate*dt && left>0 && !level_readout)
		{ // ** Emission ** //
			if (levq==2 && m) goto abort_emission; // N2: Overload
			if (levq==5 && m>6) goto abort_emission; // N5: Weird orbit
			if (levq==10 && m) // N10: No mistakes
				for (n=0;n<m;n++) if (y[n]<yres/3) goto abort_emission;
			for (n=0;n<multi;n++) if (left>0 && m<max)
			{
				x[m]=sourcex; y[m]=sourcey;
				do {xs[m]=frnd(5)-2.5; ys[m]=frnd(5)-2.5;} while (sq(xs[m])+sq(ys[m])>6.25);
				xs[m]*=0.1*levrep+1; ys[m]*=0.1*levrep+1;
				s[m]=rnd(highcolour-lowcolour+1)+lowcolour; t[m]=0;
				if (levq==6) // N6: Blackout zone [globs]
				{
					xs[m]=sin(M_PI*2*n/multi+time*10)*2;
					ys[m]=cos(M_PI*2*n/multi+time*10)*2;
					if (n>0) s[m]=s[m-n];
				}
				if (levq==8) // N8: Popcorn
				{
					x[m]=rnd(xres);
					y[m]=yres-10;
					ys[m]=-4-frnd(3);
				}
				if (levq==19) // N19: Hypersource & mines
				{
					t[m]=rnd(3);
				}
				if (levq==21) // N21: The Storm has mines
				{
					if (!rnd(4)) t[m]=1;
				}
				if (levq==22) // N22: Spontaneous formation & mines
				{
					x[m]=rnd(xres);
					y[m]=rnd(yres*3/4);
					if (!rnd(4)) t[m]=1;
				}
				if (levq==25) // N25: Variety is the spice of life...
				{
					if (!rnd(4)) t[m]=1;
					if (!rnd(15)) t[m]=2;
				}
				if (frnd(1)*(levrep*2+25)<levrep) t[m]=1;
				if (t[m]==0) {s[m]-=(int)(0.2*levrep+frnd(0.9)); if (s[m]<1) s[m]=1;}
				m++; left--;
			}
			abort_emission:;
		}
		if (levq==3 || levq==25) for (n=0;n<3;n++) // N3,25: Rain
			if (frnd(1)<0.004*dt*(levrep*0.2+1) && m<max && left>0 && !level_readout)
			{
				x[m]=fp[n*2]; y[m]=fp[n*2+1];
				do {xs[m]=frnd(3)-1.5; ys[m]=frnd(3)-1.5;} while (sq(xs[m])+sq(ys[m])>2.25);
				s[m]=8; t[m]=0;
				if (frnd(1)*(levrep*2+25)<levrep) t[m]=1;
				if (t[m]==0) {s[m]-=(int)(0.5*levrep+frnd(0.9)); if (s[m]<1) s[m]=1;}
				m++; left--;
			}
		if (levq==25 && left>10 && m<max-10 && frnd(1)<0.0004*dt) // N25: Purple droppings
		{
			for (n=m;n<m+10;n++)
			{
				x[n]=(0.5+n-m)*xres/10; y[n]=5;
				xs[n]=ys[n]=0;
				s[n]=10; t[n]=0;
			}
			m+=10; left-=10;
		}
		if ((int)(time*5)%2 || left>0 || m) // Display balls caught
		{
			float p1=(float)got[MAXP]/lpass,p2=(float)(got[MAXP]-lpass)/(total[levq-1]-lpass);
			if (got[MAXP]>=lpass)
			{
				strcpy(str,"Level passed");
				write(536,400,xres,str,16,0);
				write(534,400,xres,str,16,0);
				write(535,401,xres,str,16,0);
				write(535,399,xres,str,16,0);
				write(535,400,xres,str,15,7);
				sprintf(str,"%d",got[MAXP]);
			}
			else sprintf(str,"%d / %d",got[MAXP],lpass);
			write(499,400,xres,str,16,0);
			write(500,399,xres,str,16,0);
			write(500,401,xres,str,16,0);
			write(501,400,xres,str,16,0);
			write(500,400,xres,str,15,7);
			p1*=25; p2*=25;
			if (lpass<=25) p1=floor(p1);
			if (total[levq-1]-lpass<=25) p2=floor(p2);
			for (px=500;px<575;px+=3)
			{
				float led=(px-500)/3;
				if (led>p1) rect(px,410,2,10,20);
				else if (led+1>p1)
				{
					rect(px,410,2,10,20);
					rect(px,410,2,10.0*(p1-floor(p1)),25);
				}
				else if (led>p2) rect(px,410,2,10,25);
				else if (led+1>p2)
				{
					rect(px,410,2,10,25);
					rect(px,410,2,10.0*(p2-floor(p2)),31);
				}
				else rect(px,410,2,10,31);
			}
		}
		if (!left && !m && !leave) // Finished level!
		{
			memcpy(back,shad,xres*yres);
			levelbonusN(them,history);
			nlevel++;
			calclevelN(&levq,&levrep);
			level_readout=300;
			level_start=1;
		}
		if (level_readout) // Level introduction
		{
			n=Min(level_readout*10,(300-level_readout)*10);
			n=Min(n,xres/2);
			blackbox(xres/2-n,yres/2-10,n*2,30);
			if (n>=80)
			{
				sprintf(str,"Level N%d",nlevel);
				strlwr(str);
				if (300-level_readout<18) strbound(str,300-level_readout+40);
				else if (300-level_readout<44) strbound(str,300-level_readout-18+'a');
				bwrite(xres/2-4.5*strlen(str),yres/2-4,xres,str,(level_readout>150)?31:16+level_readout/10);
				if (levrep) sprintf(str,"%s %d",subtitle[levq-1],levrep+1);
					else strcpy(str,subtitle[levq-1]);
				strlwr(str);
				if (300-level_readout<18) strbound(str,300-level_readout+40);
				else if (300-level_readout<44) strbound(str,300-level_readout-18+'a');
				n=((level_readout>75)?31:16+level_readout/5);
				write(xres/2-0.5*estlength(str),yres/2+10,xres,str,n,8+n/2);
			}
			level_readout-=(int)(dt+0.5);
			if (level_readout<0) level_readout=0;
			grav=8; dispsource=1; rate=20;
			for (n=0;n<=MAXP;n++) got[n]=0;
			lpass=pass[levq-1]*(0.2*levrep+1); left=total[levq-1]*(0.2*levrep+1);
			if (lpass>100) lpass=lpass/10*10;
			if (left>100) left=left/10*10;
			if (lpass>5000) lpass=5000;
			if (left>5000) left=5000;
			lowcolour=3; highcolour=7; multi=1;
			if (levq==1) grav=5;
			else if (levq==2) {grav=6; multi=50; lowcolour=7; highcolour=8;}
			else if (levq==3) {grav=7; rate=0; dispsource=0;}
			else if (levq==5) grav=25;
			else if (levq==6) {multi=6; rate=3;}
			else if (levq==7) rate=10;
			else if (levq==8) {lowcolour=2; highcolour=3; rate=10; dispsource=0;}
			else if (levq==9) {rate=15; lowcolour=4;}
			else if (levq==10) lowcolour=highcolour=1;
			else if (levq==11) grav=1;
			else if (levq==13) {grav=20; highcolour=3;}
			else if (levq==14) rate=15;
			else if (levq==15) {grav=0; rate=10;}
			else if (levq==16) rate=18;
			else if (levq==17) rate=18;
			else if (levq==18) rate=40;
			else if (levq==19) rate=10;
			else if (levq==22) {rate=10; dispsource=0;}
			else if (levq==23) highcolour=10;
			else if (levq==24) {rate=30; lowcolour=highcolour=5;}
			else if (levq==25) {lowcolour=7; highcolour=8; multi=5; rate=1;}
			rate*=0.2*levrep+1;
		}
		if (leave && got[MAXP]>=lpass) memcpy(back,shad,xres*yres);
		dispscores(them,score);
		gtdisp(gametime=0.001*GetTickCount()-gamestart,openfile); // Game-time display
		if (KEY(VK_P)) if (pause()) return Error;
		cclb();
		if (KEY(VK_ESCAPE) || KEY(VK_F12)) {mouseoff(); p=1; goto unallocN;}
		while ((dt=0.001*GetTickCount()-time)<0.001*mswait) if (dealwithmessages()) return Error;
		dt/=0.001*mswait; if (dt>10) dt=10; else if (dt<1) dt=1;
	}
	p=0;
	unallocN:
	free(x); free(y); free(xs); free(ys); free(s); free(t);
	free(bx); free(bxs); free(brad); free(bh);
	free(ex); free(ey); free(er);
	for (n=0;n<10;n++) free(ball[n]);
	free(cloudel); free(cloud); free(mine);
	free(note);
	if (p) return Quit;
	if (got[MAXP]>=lpass) // Passed
	{
		levelbonusN(them,history);
		nlevel++;
	}
	if (got[MAXP]>=lpass || nlevel>startlevel) return Pass;
	else return Fail;
}

