#include <stdlib.h>
#include <string.h>

#define Bit(x,n) (((x)>>(n))&1)

double Max(const double a,const double b)
{
	return (a>b)?a:b;
}

double Min(const double a,const double b)
{
	return (a<b)?a:b;
}

int Maxi(const int a,const int b)
{
	return (a>b)?a:b;
}

int Mini(const int a,const int b)
{
	return (a<b)?a:b;
}

char lc(const char c)
{
	return (c>='A' && c<='Z')?c+32:c;
}

char uc(const char c)
{
	return (c>='a' && c<='z')?c-32:c;
}

double sq(const double x)
{
	return x*x;
}

double cu(const double x)
{
	return x*x*x;
}

double invsq(const double x)
{
	return 1.0/x/x;
}

double noneg(const double x)
{
	return (x<0)?0:x;
}

int nonegi(const int x)
{
	return (x<0)?0:x;
}

double frnd(const double lim)
{
	return (double)rand()/RAND_MAX*lim;
}

int rnd(const int lim)
{
	return (int)frnd((double)lim-0.0001);
}

const int pot[10]={1,2,4,8,16,32,64,128,256,512};

void set(unsigned char *array,const int pos,const int value)
{
	if (value) array[pos/8]|=pot[pos%8];
		else array[pos/8]&=~pot[pos%8];
}

int bit(const unsigned char *array,const int pos)
{
	return (array[pos/8]&pot[pos%8])>0;
}

void rle(unsigned char **a,int *length)
{
	int n,i,e,c,r,f[256];
	unsigned char *b=(unsigned char *)malloc(*length*3+1),*ret;
	for (n=0;n<*length;n++) f[(*a)[n]]++;
	e=0;
	for (n=1;n<256;n++) if (f[n]<f[e]) e=n;
	b[0]=e; i=1; c=-1; r=0;
	for (n=0;n<=*length;n++)
	{
		unsigned char x=(n<*length)?(*a)[n]:-1;
		if (x!=c)
		{
			if (c>=0)
			{
				if (r==1 && c!=e) b[i++]=c;
				else if (r==2 && c!=e) {b[i++]=c; b[i++]=c;}
				else if (r==3 && c!=e) {b[i++]=c; b[i++]=c; b[i++]=c;}
				else {b[i++]=e; b[i++]=c; b[i++]=r;}
			}
			c=x; r=1;
		}
		else if (r<255) r++;
		else
		{
			b[i++]=e; b[i++]=c; b[i++]=r;
			c=x; r=1;
		}
	}
	free(*a);
	ret=(unsigned char *)malloc(i); memcpy(ret,b,i); free(b);
	*a=ret; *length=i;
}

void unrle(unsigned char **a,int *length)
{
	int n,i,j,e=**a;
	unsigned char *b;
	i=0;
	for (n=1;n<*length;n++)
	{
		if ((*a)[n]==e) {i+=(*a)[n+2]; n+=2;}
		else i++;
	}
	b=(unsigned char *)malloc(i); i=0;
	for (n=1;n<*length;n++)
	{
		if ((*a)[n]==e) {for (j=0;j<(*a)[n+2];j++) b[i++]=(*a)[n+1]; n+=2;}
		else b[i++]=(*a)[n];
	}
	free(*a);
	*a=b; *length=i;
}

